//
// Basic wrapper for OpenGL VBO extension
//
// Author: Alex V. Boreskoff, <steps3d@narod.ru>
//

#include	"VertexBuffer.h"

VertexBuffer :: VertexBuffer ()
{
	glGenBuffersARB ( 1, &id );
	
	ok     = ( glIsBufferARB ( id ) == GL_TRUE );
	target = 0;
}

VertexBuffer :: ~VertexBuffer ()
{
	glDeleteBuffersARB ( 1, &id );
}

void	VertexBuffer :: bind ( GLenum theTarget )
{
	glBindBufferARB ( target = theTarget, id );
}

void	VertexBuffer :: unbind ()
{
	glBindBufferARB ( target, 0 );
}

void	VertexBuffer :: setData ( unsigned size, const void * ptr, GLenum usage )
{
	glBufferDataARB ( target, size, ptr, usage );
}

void	VertexBuffer :: setSubData ( unsigned offs, unsigned size, const void * ptr )
{
	glBufferSubDataARB ( target, offs, size, ptr );
}

void  * VertexBuffer :: map ( GLenum access )
{
	return glMapBufferARB ( target, access );
}

bool	VertexBuffer :: unmap ()
{
	return glUnmapBufferARB ( target ) == GL_TRUE;
}

bool	VertexBuffer :: isSupported ()
{
	return isExtensionSupported ( "GL_ARB_vertex_buffer_object" );
}
