
uniform sampler2D mainMap;


void main(void)
{
	const vec3	luminance = vec3 ( 0.3, 0.59, 0.11 );
	
	vec2 dx   = vec2 ( 1.0 / 512.0, 0.0 );
	vec2 dy   = vec2 ( 0.0, 1.0 / 512.0 );
	vec4 base = texture2D ( mainMap, gl_TexCoord [0].xy ) +
                texture2D ( mainMap, gl_TexCoord [0].xy + dx ) +
                texture2D ( mainMap, gl_TexCoord [0].xy + dy ) +
                texture2D ( mainMap, gl_TexCoord [0].xy + dx + dy );

	base *= 0.25;

	float	lum = dot ( base.rgb, luminance );
	
	base *= ( smoothstep ( 0.25, 1.0, lum ) - 0.25) / 0.75;
	
	gl_FragColor = base;
}
